local name = "block"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    ---interact
    opt.state = opt.state or "normal"
    if opt.disabled then
        opt.state = "disabled"
    else
        core:updateState(opt)
    end
    ---draw
    core:applyLayout(opt)
    opt.draw = opt.draw or core.render[name]
    opt.style = opt.style or core.style
    core:registerDraw(opt.draw ,{opt.style,opt})
    
    return opt
end