local name = "combo"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    ---interact
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    opt.submit = false
    core:applyLayout(opt)
    if opt.disabled then
        opt.state = "disabled"
    else
        local s = opt.h - 2
        opt.listButton = opt.listButton or 
        {x = opt.x + opt.w - s ,y = opt.y + 1,w = s,h =s,dir = "down"}
        opt.menu = opt.menu or 
        {x = opt.x+4,y= opt.y+opt.h,w = opt.w - s,h = opt.h*#opt.options,
            rowH  = opt.h,children = opt.options,vert = true,font = opt.font}
        opt.input = opt.input or 
            {x = opt.x+1,y= opt.y+1,
                w = opt.w - s,h = opt.h-2,text = opt.text,
                aline = "center",noStroke = true,font = opt.font}
        opt.panel = opt.panel or {x = opt.x,y=opt.y,w=opt.w,h=opt.h,withStyle= true}
        local input = opt.input
        local menu = opt.menu
        local listButton = opt.listButton
        local panel = opt.panel
        listButton.x = opt.x + opt.w - s
        listButton.y = opt.y + 1
        
        
        core:doWidget("arrow",listButton)
        core:doWidget("text",input)
        if input.editing then
            listButton.dir = "down"
        else
            input.text = opt.text
        end
        if input.submit then
            opt.text = input.submit
            opt.submit = opt.text
        end
        core:doWidget("panel",panel)
        if listButton.hit then
            listButton.dir = listButton.dir == "up" and "down" or "up" 
        end
        
        if listButton.dir == "up" then
            core:doWidget("menu",menu)
            if menu.choose then
                opt.text = menu.choose.text
                listButton.dir = "down"
                opt.submit = opt.text
            end
        end
    end
    ---draw

    core:updateBound(opt)
    
    return opt
end