local name = "list"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    ---interact
    opt.font = opt.font or core.style.newFont()
    opt.state = opt.state or "normal"
    core:applyLayout(opt)
    opt.submit = nil
    if opt.disabled then
        opt.state = "disabled"
    else
        local s = opt.h - 2
        opt.listButton = opt.listButton or {
            x = opt.x + opt.w - s ,y = opt.y + 1,w = s,h =s,dir = "down"}
        opt.menu = opt.menu or 
        {x = opt.x+4,y= opt.y+opt.h,w = opt.w - s,h = opt.h*#opt.options,
            rowH  = opt.h,children = opt.options,vert = true,font = opt.font}
        opt.label = opt.label or 
        {x = opt.x,y= opt.y,w = opt.w - s,h = opt.h,text = opt.text,font = opt.font}
        opt.panel = opt.panel or {x = opt.x,y=opt.y,w=opt.w,h=opt.h,withStyle= true}
        local label = opt.label
        local menu = opt.menu
        local listButton = opt.listButton
        local panel = opt.panel
        
        label.x = opt.x
        label.y = opt.y
        panel.x = opt.x
        panel.y = opt.y
        menu.x = opt.x+4
        menu.y = opt.y+opt.h
        listButton.x = opt.x + opt.w - s
        listButton.y = opt.y + 1
        label.text = opt.text
        
        label.container = opt.container
        panel.container = opt.container
        listButton.container = opt.container
        
        core:doWidget("arrow",listButton)
        core:doWidget("label",label)
        core:doWidget("panel",panel)
        if listButton.hit then
            listButton.dir = listButton.dir == "up" and "down" or "up" 
        end
        
        if listButton.dir == "up" then
            core:doWidget("menu",menu)
            if menu.choose then
                opt.text = menu.choose.text
                listButton.dir = "down"
                opt.submit = opt.text
            end
        end
    end
    ---draw

    core:updateBound(opt)
    
    return opt
end