local name = "tip"
local max_w = 150
return function(core,target)
    local tip_text = target.tip
    
    if not core.tip_obj then
        local opt = {x = core.mouse_x ,y = core.mouse_y - 10}
        opt.font = opt.font or core.style.newFont()
        opt.state = opt.state or "normal"
        local font = opt.font.normal.obj
        local fh = font:getHeight("H")
        local tw = font:getWidth(tip_text)
        if tw + 4 < max_w then
            opt.w = tw + 4
            opt.h = fh + 4
        else
            opt.w = max_w + 4
            opt.h = fh * math.ceil(tw / (max_w + 4))
            opt.multiLine = true
        end
        opt.y = opt.y - opt.h
        opt.text = tip_text
        opt.aline =  {x = "center",y = "center"}
        core.tip_obj = opt
        opt.noRound = true
        opt.noGrad = true
    end
    local opt = core.tip_obj
    opt.draw = opt.draw or core.render[name]
    opt.style = opt.style or core.style
    core:registerDraw(opt.draw ,{opt.style,opt},true)
    return target
end