local name = "base"
return function(core,opt)
    opt.id = opt.id or tostring(name.."_"..tostring(opt))
    ---interact
    if opt.disabled then
        opt.state = "disabled"
    else
        opt.state = core:registerHitbox(opt, core:getRect(opt))
        core:switchToggle(opt)
        opt.hit = core:mouseReleasedOn(opt) and opt == core:getHovered()
        opt.drag = core:mouseReleasedOn(opt) and core:getActive() and core:getActive() ~= opt
        opt.drag_from = core:getActive()
        opt.hovered = core:isHovered(opt)
        opt.entered = core:isHovered(opt) and not core:wasHovered(opt)
        opt.left = not core:isHovered(opt) and core:wasHovered(opt)
    end
    ---draw
    core:applyLayout(opt)
    opt.draw = opt.draw or core.theme.base
    opt.style = opt.style or core.style
    core:registerDraw(opt.draw ,{opt.style,opt})
    
    return opt
end