local label_text = {text = "label",layout = {1,1}}
local label = {text = "i am labelxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",layout = {2,1,2,1},wrapLine = true}
local label2 = {text = "i am label",layout = {4,1}}
local button_text = {text = "button",layout = {1,2}}
local button = {text = "i am button",layout = {2,2,2,1}}
local button2 = {text = "toggle button",layout = {4,2,2,1},toggle = false}
local check_text = {text = "check",layout = {1,3}};local check = {layout = {2,3}}
local radio_text = {text = "radio",layout = {1,4}};local radio = {layout = {2,4}}

local arrow_text = {text = "arrow",layout = {3,3}};local arrow = {layout = {4,3},dir = "left"}

local image_text = {text = "image",layout = {1,5}};
local image = {layout = {2,5,2,2},path = "/love-ball.png",adjust = true}
local image2 = {layout = {4,4,2,3},path = "/love-ball.png",aline = {x = "right",y = "bottom"}}
local image3 = {layout = {6,5,1,1},path = "/love-ball.png",aline = {x = "left",y = "top"},noFrame = true}
local panel_text = {text = "panel",layout = {1,7}};local panel = {layout = {2,7,3,1}}
local prog_text = {text = "progress",layout = {1,8}};local progress = {layout = {2,8,3,1},value = 0.65}
local slider_text = {text = "slider",layout = {1,9}};local slider = {layout = {2,9,3,1},
    min = 1,max = 9,step = 1,value = 7
}
local cp_text = {text = "color",layout = {1,10}};local cp = {layout = {2,10,2,1}}
local text1 = {text = "你好中文12345",layout = {1,12,2,1},aline = "left",debug = true}
local text2 = {text = "你好中文12345",layout = {1,13,2,1},aline = "right"}
local text3 = {text = "你好中文12345",layout = {1,14,2,1},aline = "center"}

local number_text = {text ="数字框，可设定格式，悬停加方向键调节",layout = {1,15,3,1}}
local number = {value = 5,layout = {1,16}}

local tip = {layout = "down",text = "悬停2秒",tip = "现在你可以看到我了"}
local stencil = {text = "no stencil",toggle = false,layout = "down"}

local frame = {layout = {11,2,3,3},
    title = "hello1",close = false,min = true,resizable = true,movable = true,
    cell = {50,20},
    children = {
        {type = "label",text = "你好1",layout = "right"},
        {type = "label",text = "你好2",layout = "right"},
        {type = "label",text = "你好3",layout = "right"},
        {type = "label",text = "你好4",layout = "right"},
        {type = "label",text = "你好5",layout = "right"},
        {type = "label",text = "你好6",layout = "right"},
        }
    }


local frame2 = {layout = {11,5,3,3},
    title = "hello2",close = true,min = true,resizable = true,movable = true,
    window = {w = 300, h = 300},
    grid = {6,5},
    children = {
        {type = "button",text = "你好1",layout = "down"},
        {type = "button",text = "你好2",layout = "down"},
        {type = "button",text = "你好3",layout = "down"},
        {type = "button",text = "你好1",layout = "down"},
        {type = "button",text = "你好2",layout = "down"},
        {type = "button",text = "你好3",layout = "down"},
        }
    }

local frame3 = {layout = {11,10,3,3},
    title = "hello3",close = true,min = true,resizable = true,movable = true,
    window = {w = 300, h = 300},
    userDraw = function()
        for r = 1,10 do
            love.graphics.setColor(0.6,1,0.6, 1 - r/10)
            love.graphics.circle("fill",r*10 , r * 10,r*20)
        end
    end
    }




local menu = {layout = {7,2,3,1},vert = false,children = {
        {text = "菜单1"},
        {text = "菜单2"},
        {text = "菜单3",sub = {
                    vert = true,
                    children = {
                        {text = "子菜单1"},
                        {text = "子菜单2",sub = {
                                children = {
                                    {path = "/love-ball.png",adjust = true,noFrame = true},
                                    {text = "次菜单2"}
                                    
                                    }
                                }}
                        
                        }
                }}
        }}

local list = {layout = {7,5,2,1},text = "未设定",options = {
        {text = "测试1"},
        {text = "测试2"}
    }}

local combo = {layout = {7,8,2,1},text = "未设定",options = {
        {text = "测试1"},
        {text = "测试2"}
    }}


local tab = {
    layout = {11,12,3,4},
    window = {w = 300,h = 300},
    close = true,
    movable = true,
    children = {
        frame,frame2,frame3
        }}




local example = {}
function example:update()
    ui.layout:setWindow()
    ui.layout:setCell(100,30)
    ui.label(label_text);ui.label(label);ui.label(label2)

    ui.label(button_text);ui.button(button);ui.button(button2)
    ui.label(check_text);ui.check(check);
    ui.label(arrow_text); 
    if ui.arrow(arrow).hit then 
        arrow.dir = arrow.dir == "right" and "left" or "right" 
    end
    ui.label(radio_text);ui.radio(radio)
    ui.label(image_text);ui.image(image);ui.image(image2);ui.image(image3)
    ui.label(panel_text);ui.panel(panel)
    ui.label(prog_text);ui.progress(progress)
    ui.label(slider_text);ui.slider(slider)
    progress.value = (slider.value - slider.min)/(slider.max - slider.min)
    ui.label(cp_text);ui.colorpicker(cp)
    ui.text(text1)
    ui.text(text2)
    ui.text(text3)
    ui.menu(menu)
    ui.list(list)
    ui.combo(combo)
    ui.label(number_text)
    ui.number(number)
    ui.label(tip)
    ui.button(stencil)
    ui.tab(tab)

end

return example
